unit utuEmprestimoOQL;

interface

uses acuOQL, acuFramework;

type

  IObterExemplares = interface(IOQLQuery)
    function Param_titulo: acOQLParamString;
    function Param_isbn: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

  IObterUsuarios = interface(IOQLQuery)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  utEmprestimoOQL = class
    class function ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
    class function ObterUsuarios(piSessao: acPersistenceSession): IObterUsuarios;
  end;

implementation

type

  TObterExemplares = class(acOQLQuery, IObterExemplares)
    function Param_titulo: acOQLParamString;
    function Param_isbn: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

  TObterUsuarios = class(acOQLQuery, IObterUsuarios)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

{ TObterExemplares }

function TObterExemplares.Param_titulo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('titulo'));
end;

function TObterExemplares.Param_isbn: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('isbn'));
end;

function TObterExemplares.Param_codigo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('codigo'));
end;

{ TObterUsuarios }

function TObterUsuarios.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterUsuarios.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ utOQLs }

class function utEmprestimoOQL.ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
begin
  result := TObterExemplares.Create(pisessao,
'SELECT ngExemplar' + #13#10 +
'FROM ngExemplar,' + #13#10 +
'     ngExemplar.Livro' + #13#10 +
'WHERE (ngExemplar.Livro.Titulo LIKE ''%''+?titulo:acString+''%'' OR ?titulo:acString IS NULL)' + #13#10 +
'        AND (ngExemplar.Livro.ISBN = ?isbn:acString OR ?isbn:acString IS NULL)' + #13#10 +
'	AND (ngExemplar.Codigo = ?codigo:acString OR ?codigo:acString IS NULL)' + #13#10 +
'ORDER BY ngExemplar.Livro.OID ASC');
end;

class function utEmprestimoOQL.ObterUsuarios(piSessao: acPersistenceSession): IObterUsuarios;
begin
  result := TObterUsuarios.Create(pisessao,
'SELECT ngUsuario' + #13#10 +
'FROM ngUsuario' + #13#10 +
'WHERE (ngUsuario.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL)' + #13#10 +
'	AND (ngUsuario.CPF = ?cpf:acString OR ?cpf:acString IS NULL)');
end;

end.
